Memory leak in notify-osd in cairo surface creation - or what is left after fix for 378193

Bug #405364 reported by Alexander Sack on 2009-07-27
26
This bug affects 5 people
Affects Status Importance Assigned to Milestone
notify-osd (Ubuntu)
High
Mirco Müller

Bug Description

after landing of bug 378193 i still see this leak, which seems to be like a similar fix would do:

==16630== 27,616 (2,368 direct, 25,248 indirect) bytes in 8 blocks are definitely lost in loss record 205 of 218
==16630== at 0x4C278AE: malloc (vg_replace_malloc.c:207)
==16630== by 0x6DAF303: (within /usr/lib/libcairo.so.2.10800.8)
==16630== by 0x6DAF657: (within /usr/lib/libcairo.so.2.10800.8)
==16630== by 0x412776: _refresh_background (bubble.c:517)
==16630== by 0x41373E: bubble_recalc_size (bubble.c:3268)
==16630== by 0x41AFA9: stack_notify_handler (stack.c:645)
==16630== by 0x41A095: dbus_glib_marshal_stack_VOID__STRING_UINT_STRING_STRING_STRING_BOXED_BOXED_INT_POINTER (stack-glue.h:100)
==16630== by 0x52797EB: (within /usr/lib/libdbus-glib-1.so.2.1.0)
==16630== by 0x5279CA4: (within /usr/lib/libdbus-glib-1.so.2.1.0)
==16630== by 0x54AB61D: (within /lib/libdbus-1.so.3.4.0)
==16630== by 0x549F3DB: dbus_connection_dispatch (in /lib/libdbus-1.so.3.4.0)
==16630== by 0x5276B64: (within /usr/lib/libdbus-glib-1.so.2.1.0)

Alexander Sack (asac) wrote :

still High importance imo as its important to get a leak free notify-osd.

Changed in notify-osd:
status: New → Confirmed
Alexander Sack (asac) wrote :

not as huge mem leak as bug 378193, but still worth a milestone; linux has the reputation to run without problems for a long time; having notify-osd leaking could cause the opposite experience for users.

Changed in notify-osd (Ubuntu):
importance: Undecided → High
milestone: none → ubuntu-9.10-beta
status: New → Triaged
Alexander Sack (asac) wrote :

most leaks fixed in lp:~asac/notify-osd/lp405364_more_memleaks (attached to bug) ... requested merge.

Architecture: i386
DistroRelease: Ubuntu 9.10
GtkTheme: Shiki-Human
IconTheme: gnome-human
MachineType: LENOVO 8933Y16
Package: notify-osd 0.9.15-0ubuntu2
PackageArchitecture: i386
ProcCmdLine: BOOT_IMAGE=/boot/vmlinuz-2.6.31-4-generic root=UUID=8920ca3c-8a9b-4b68-893c-1fec8a7cf652 ro quiet splash
ProcEnviron:
 SHELL=/bin/bash
 PATH=(custom, user)
 LANG=en_US.UTF-8
ProcVersionSignature: Ubuntu 2.6.31-4.23-generic
RelatedPackageVersions:
 xserver-xorg 1:7.4+3ubuntu5
 libgl1-mesa-glx 7.5-1ubuntu1
 libdrm2 2.4.12-1ubuntu1
 xserver-xorg-video-intel 2:2.8.0-0ubuntu1
 xserver-xorg-video-ati 1:6.12.99+git20090629.f39cafc5-0ubuntu1
Uname: Linux 2.6.31-4-generic i686
UserGroups: adm admin cdrom dialout lpadmin plugdev sambashare
WindowManager: compiz
dmi.bios.date: 06/28/2007
dmi.bios.vendor: LENOVO
dmi.bios.version: 7OET24WW (1.03 )
dmi.board.name: 8933Y16
dmi.board.vendor: LENOVO
dmi.board.version: Not Available
dmi.chassis.asset.tag: No Asset Information
dmi.chassis.type: 10
dmi.chassis.vendor: LENOVO
dmi.chassis.version: Not Available
dmi.modalias: dmi:bvnLENOVO:bvr7OET24WW(1.03):bd06/28/2007:svnLENOVO:pn8933Y16:pvrThinkPadR61/R61i:rvnLENOVO:rn8933Y16:rvrNotAvailable:cvnLENOVO:ct10:cvrNotAvailable:
dmi.product.name: 8933Y16
dmi.product.version: ThinkPad R61/R61i
dmi.sys.vendor: LENOVO

Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :

Architecture: i386
DistroRelease: Ubuntu 9.10
GtkTheme: Shiki-Human
IconTheme: gnome-human
MachineType: LENOVO 8933Y16
Package: notify-osd 0.9.15-0ubuntu2
PackageArchitecture: i386
ProcCmdLine: BOOT_IMAGE=/boot/vmlinuz-2.6.31-4-generic root=UUID=8920ca3c-8a9b-4b68-893c-1fec8a7cf652 ro quiet splash
ProcEnviron:
 SHELL=/bin/bash
 PATH=(custom, user)
 LANG=en_US.UTF-8
ProcVersionSignature: Ubuntu 2.6.31-4.23-generic
RelatedPackageVersions:
 xserver-xorg 1:7.4+3ubuntu5
 libgl1-mesa-glx 7.5-1ubuntu1
 libdrm2 2.4.12-1ubuntu1
 xserver-xorg-video-intel 2:2.8.0-0ubuntu1
 xserver-xorg-video-ati 1:6.12.99+git20090629.f39cafc5-0ubuntu1
Uname: Linux 2.6.31-4-generic i686
UserGroups: adm admin cdrom dialout lpadmin plugdev sambashare
WindowManager: compiz
dmi.bios.date: 06/28/2007
dmi.bios.vendor: LENOVO
dmi.bios.version: 7OET24WW (1.03 )
dmi.board.name: 8933Y16
dmi.board.vendor: LENOVO
dmi.board.version: Not Available
dmi.chassis.asset.tag: No Asset Information
dmi.chassis.type: 10
dmi.chassis.vendor: LENOVO
dmi.chassis.version: Not Available
dmi.modalias: dmi:bvnLENOVO:bvr7OET24WW(1.03):bd06/28/2007:svnLENOVO:pn8933Y16:pvrThinkPadR61/R61i:rvnLENOVO:rn8933Y16:rvrNotAvailable:cvnLENOVO:ct10:cvrNotAvailable:
dmi.product.name: 8933Y16
dmi.product.version: ThinkPad R61/R61i
dmi.sys.vendor: LENOVO

Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
Rami Al-Rfou' (rmyeid) wrote :
tags: added: apport-collected
Rami Al-Rfou' (rmyeid) wrote :

sorry for the mess happened. The first time I used apport-collect it gave me an error so I made it again, and the surprise that I have two copies of the collected reports.
What I wanted to say that after running karmic for more than 20 hours it consumes 180MB !

David Barth (dbarth) on 2009-09-16
Changed in notify-osd:
importance: Undecided → High
assignee: nobody → Mirco Müller (macslow)
milestone: none → ubuntu-9.10-beta-freeze
David Barth (dbarth) on 2009-09-18
Changed in notify-osd (Ubuntu):
assignee: nobody → Mirco Müller (macslow)
Mirco Müller (macslow) on 2009-09-24
Changed in notify-osd:
status: Confirmed → Fix Committed
Changed in notify-osd (Ubuntu):
status: Triaged → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package notify-osd - 0.9.22-0ubuntu1

---------------
notify-osd (0.9.22-0ubuntu1) karmic; urgency=low

  * New upstream version: notify-osd has been scrutinized thoroughly
    under valgrind to identify all mem-leaks and invalid reads.
    (LP: #427924, #375408, #405364, #378193, #428302)

 -- Sebastien Bacher <email address hidden> Thu, 24 Sep 2009 16:14:59 +0200

Changed in notify-osd (Ubuntu):
status: Fix Committed → Fix Released
David Barth (dbarth) on 2009-09-25
Changed in notify-osd:
status: Fix Committed → Fix Released
Johansen (johansense) wrote :

This is not fixed yet.
Let me know what other info you need.

notify-osd:
  Installed: 0.9.24-0ubuntu1
  Candidate: 0.9.24-0ubuntu1
  Version table:
 *** 0.9.24-0ubuntu1 0
        500 http://us.archive.ubuntu.com karmic/main Packages
        100 /var/lib/dpkg/status
 ps auxw | grep notify-osd | grep -v gre
2028 0.0 0.5 32972 11004 ? S 14:13 0:02 /usr/lib/notify-osd/notify-osd

I can watch the process increase in memory proportionally to the album art file size, it doesn't matter what media player i'm using.

-Eldon

Johansen (johansense) on 2009-11-26
Changed in notify-osd:
status: Fix Released → Incomplete
Robert Collins (lifeless) wrote :

Well it has to grow to hold the art, but it shouldn't leak. Are you sure that its a leak, and not just the current album art overhead?

Johansen (johansense) wrote :

I had it up to (IIRC) 456MB, then it crashed.
i am attempting to replicate this.
Unfortunately my computer freezes up approximately once a day.
In 6 hours time it is up to 120MB, same album on repeat.

reacocard (reacocard) wrote :

I'm experiencing this same issue with the notify-osd plugin for Exaile (rev 2783) under Arch Linux x86_64 and notify-osd revision 407 . Notify-osd resident memory grows every time the bubble is shown with album art. I've seen this be as high as 6MB for a single track change notification, and have had the memory use grow to over 500MB. After killing notify-osd it will start again from about 13MB, but grows to large sizes again quite readily.

Please let me know if you need any additional information or a patch tested.

samlabs821 (samlabs821) wrote :

I agree with you Aren. I have the same problem. I think the problen is in Banshee player.

Caste (carstenhaubold) wrote :

I can confirm this issue, it must be either Pidgin or Exaile, which are the only applications from which I see notify-osd-popups. (On Ubuntu 10.04, 64bit)

Closing Exaile and Pidgin does not reduce the size of allocated memory by notify-osd (currently at 350mb), so this definitely sounds like a leakage problem.

Peter Kerekfy (kerekfyp) wrote :

+1 with banshee player on 9.10

corresponding top line:

 2652 kerekfyp 20 0 419m 291m 3552 S 0 8.9 0:26.75 notify-osd

Karl Lattimer (karl-qdh) wrote :

Anyone wishing to add further, more up to date valgrind reports on this bug should do so on bug #610389 instead.
This specific issue is considered fixed, but it is expected there may be a few more in need of fixing.

Changed in notify-osd:
status: Incomplete → Fix Released
no longer affects: notify-osd
To post a comment you must log in.